package sun.tracing.dtrace;

import java.util.Iterator;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import com.sun.tracing.Provider;
import com.sun.tracing.ProviderFactory;

public final class DTraceProviderFactory extends ProviderFactory
{
    public DTraceProviderFactory() {
    }
    
    public <T extends Provider> T createProvider(Class<T> clazz) {
        DTraceProvider dTraceProvider = new DTraceProvider(clazz);
        Provider proxyInstance = dTraceProvider.newProxyInstance();
        dTraceProvider.setProxy(proxyInstance);
        dTraceProvider.init();
        new Activation(dTraceProvider.getModuleName(), new DTraceProvider[] { dTraceProvider });
        return proxyInstance;
    }
    
    public Map<Class<? extends Provider>, Provider> createProviders(Set<Class<? extends Provider>> set, String s) {
        HashMap<Class, Provider> hashMap = new HashMap();
        HashSet<Object> set2 = new HashSet();
        for (Class key : set) {
            DTraceProvider e = new DTraceProvider(key);
            set2.add(e);
            hashMap.put(key, e.newProxyInstance());
        }
        new Activation(s, (DTraceProvider[])set2.toArray(new DTraceProvider[0]));
        return hashMap;
    }
    
    public static boolean isSupported() {
        try {
            SecurityManager securityManager = System.getSecurityManager();
            if (securityManager != null) {
                securityManager.checkPermission(new RuntimePermission("com.sun.tracing.dtrace.createProvider"));
            }
            return JVM.isSupported();
        }
        catch (SecurityException ex) {
            return false;
        }
    }
}
